Overview | Package | Class | Tree | Deprecated | Index | Help
| Java EE 5 SDK
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT

## javax.persistence
Annotation Type OneToMany

    @Target(value={METHOD,FIELD})
    @Retention(value=RUNTIME)
    public @interface OneToMany

Defines a many-valued association with one-to-many multiplicity.

If the collection is defined using generics to specify the element type, the associated target entity type need not be specified; otherwise the target entity class must be specified.

        Example 1: One-to-Many association using generics

        In Customer class:

        @OneToMany(cascade=ALL, mappedBy="customer")
        public Set getOrders() { return orders; }

        In Order class:

        @ManyToOne
        @JoinColumn(name="CUST_ID", nullable=false)
        public Customer getCustomer() { return customer; }

        Example 2: One-to-Many association without using generics

        In Customer class:

        @OneToMany(targetEntity=com.acme.Order.class, cascade=ALL,
                mappedBy="customer")
        public Set getOrders() { return orders; }

        In Order class:

        @ManyToOne
        @JoinColumn(name="CUST_ID", nullable=false)
        public Customer getCustomer() { return customer; }

Since:
  Java Persistence 1.0

Optional Element Summary
`CascadeType[]` | `cascade` (Optional) The operations that must be cascaded to the target of the association.
`FetchType` | `fetch` (Optional) Whether the association should be lazily loaded or must be eagerly fetched.
`String` | `mappedBy` The field that owns the relationship.
`Class` | `targetEntity` (Optional) The entity class that is the target of the association.

### targetEntity

    public abstract Class targetEntity

  (Optional) The entity class that is the target of the association. Optional only if the collection property is defined using Java generics. Must be specified otherwise.

  Defaults to the parameterized type of the collection when defined using generics.

  Default:
    void.class

### cascade

    public abstract CascadeType[] cascade

  (Optional) The operations that must be cascaded to the target of the association.

  Defaults to no operations being cascaded.

  Default:
    {}

### fetch

    public abstract FetchType fetch

  (Optional) Whether the association should be lazily loaded or must be eagerly fetched. The `EAGER` strategy is a requirement on the persistenceprovider runtime that the associatedentities must be eagerly fetched. The `LAZY` strategy is a hint to the persistence provider runtime.

  Default:
    LAZY

### mappedBy

    public abstract String mappedBy

  The field that owns the relationship. Required unless the relationship is unidirectional.

  Default:
    ""

Overview | Package | Class | Tree | Deprecated | Index | Help
| Java EE 5 SDK
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT

Submit a bug or feature

Copyright 2006 Sun Microsystems, Inc. All rights reserved.